// ImageComparatorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "ImageComparatorDlg.h"
#include "enh.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
        CAboutDlg();

// Dialog Data
        enum { IDD = IDD_ABOUTBOX };

        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
        DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CImageComparatorDlg dialog



CImageComparatorDlg::CImageComparatorDlg(CWnd* pParent /*=NULL*/)
        : CDialog(CImageComparatorDlg::IDD, pParent)
{
        m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CImageComparatorDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
        DDX_Control(pDX, IDC_FILE1, c_FileName1);
        DDX_Control(pDX, IDC_FILE2, c_FileName2);
        DDX_Control(pDX, IDC_OPEN1, c_OpenFile1);
        DDX_Control(pDX, IDC_OPEN2, c_OpenFile2);
        DDX_Control(pDX, IDC_HSCROLL, c_HScroll);
        DDX_Control(pDX, IDC_VSCROLL, c_VScroll);
        DDX_Control(pDX, IDC_IMAGE1, c_Image1);
        DDX_Control(pDX, IDC_IMAGE2, c_Image2);
        DDX_Control(pDX, IDC_IMAGEDELTA, c_ImageDelta);
        DDX_Control(pDX, IDC_FRAME, c_Frame);
        DDX_Control(pDX, IDC_BROWSE1, c_Browse1);
        DDX_Control(pDX, IDC_BROWSE2, c_Browse2);
        DDX_Control(pDX, IDC_COMBINE, c_CombineOp);
        DDX_Control(pDX, IDC_COMBINE_BOTH, c_CombineBoth);
        DDX_Control(pDX, IDC_COMBINE_RIGHT, c_CombineRight);
        DDX_Control(pDX, IDC_SAVE, c_Save);
}

BEGIN_MESSAGE_MAP(CImageComparatorDlg, CDialog)
        ON_WM_SYSCOMMAND()
        ON_WM_QUERYDRAGICON()
        //}}AFX_MSG_MAP
        ON_WM_CLOSE()
        ON_WM_SIZE()
        ON_WM_GETMINMAXINFO()
        ON_WM_NCHITTEST()
        ON_BN_CLICKED(IDC_OPEN1, OnBnClickedOpen1)
        ON_BN_CLICKED(IDC_OPEN2, OnBnClickedOpen2)
        ON_EN_CHANGE(IDC_FILE1, OnEnChangeFile1)
        ON_EN_CHANGE(IDC_FILE2, OnEnChangeFile2)
        ON_BN_CLICKED(IDC_BROWSE1, OnBnClickedBrowse1)
        ON_BN_CLICKED(IDC_BROWSE2, OnBnClickedBrowse2)
        ON_BN_CLICKED(IDC_COMBINE_BOTH, OnBnClickedCombineBoth)
        ON_BN_CLICKED(IDC_COMBINE_RIGHT, OnBnClickedCombineRight)
        ON_BN_CLICKED(IDC_SAVE, OnBnClickedSave)
        ON_CBN_SELENDOK(IDC_COMBINE, OnCbnSelendokCombine)
END_MESSAGE_MAP()


static const IDData BLTs[] ={
   { IDS_OR, SRCPAINT },
   { IDS_XOR, SRCINVERT},
   { IDS_XOR_ENH, ENH_SRCINVERT},
   { IDS_AND, SRCERASE},
   { IDS_ORNOT, NOTSRCERASE},
   { 0, 0} // EOT
};
// CImageComparatorDlg message handlers

/****************************************************************************
*                      CImageComparatorDlg::OnInitDialog
* Result: BOOL
*       TRUE, always
* Effect: 
*       Initializes controls
****************************************************************************/

BOOL CImageComparatorDlg::OnInitDialog()
   {
    CDialog::OnInitDialog();

    // Add "About..." menu item to system menu.

    // IDM_ABOUTBOX must be in the system command range.
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
       {
        CString strAboutMenu;
        strAboutMenu.LoadString(IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty())
           {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
           }
       }

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);                 // Set big icon
    SetIcon(m_hIcon, FALSE);                // Set small icon

    // TODO: Add extra initialization here
        
    c_Image1.bkcolor = RGB(255, 0, 0);
    c_ImageDelta.bkcolor = RGB(0, 255, 0);
    c_Image2.bkcolor = RGB(0, 0, 255);

    c_OpenFile1.SetDirection(DrawArrow::ARROW_S);
    c_OpenFile2.SetDirection(DrawArrow::ARROW_S);
    CRect r;
    GetClientRect(&r);
    SizeWindows(r.Width(), r.Height());

    c_CombineOp.AddStrings(BLTs, SRCINVERT);

    updateControls();

    return TRUE;  // return TRUE  unless you set the focus to a control
}

/****************************************************************************
*                      CImageComparatorDlg::OnSysCommand
* Inputs:
*       UINT nID: Control ID
*       LPARAM lParam:
* Result: void
*       
* Effect: 
*       Handles system command
****************************************************************************/

void CImageComparatorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
        if ((nID & 0xFFF0) == IDM_ABOUTBOX)
        {
                CAboutDlg dlgAbout;
                dlgAbout.DoModal();
        }
        else
        {
                CDialog::OnSysCommand(nID, lParam);
        }
}

/****************************************************************************
*                    CImageComparatorDlg::OnQueryDragIcon
* Result: HCURSOR
*       
****************************************************************************/

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CImageComparatorDlg::OnQueryDragIcon()
{
        return static_cast<HCURSOR>(m_hIcon);
}

/****************************************************************************
*                        CImageComparatorDlg::OnClose
* Result: void
*       
* Effect: 
*       Closes the app
****************************************************************************/

void CImageComparatorDlg::OnClose()
    {
     CDialog::OnOK();
    } // CImageComparatorDlg::OnClose

/****************************************************************************
*                        CImageComparatorDlg::OnCancel
* Result: void
*       
* Effect: 
*       Does nothing; avoids closing the app if <esc> is hit
****************************************************************************/

void CImageComparatorDlg::OnCancel()
    {
    } // CImageComparatorDlg::OnCancel

/****************************************************************************
*                          CImageComparatorDlg::OnOK
* Result: void
*       
* Effect: 
*       Does nothing; avoids closing the app if <enter> is hit
****************************************************************************/

void CImageComparatorDlg::OnOK()
    {
    } // CImageComparatorDlg::OnOK

/****************************************************************************
*                        CImageComparatorDlg::OnGetMinMaxInfo
* Inputs:
*       MINMAXINFO * lpMMI:
* Result: void
*       
* Effect: 
*       Prevents resizing below the minimum size
****************************************************************************/

void CImageComparatorDlg::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
    {
     if(c_Frame.GetSafeHwnd() != NULL)
        { /* limit size */
         CRect r;
         c_Frame.GetWindowRect(&r);
         ScreenToClient(&r);
         CalcWindowRect(&r);
         lpMMI->ptMinTrackSize.x = r.Width();
         lpMMI->ptMinTrackSize.y = r.Height();
         return;
        } /* limit size */
     CDialog::OnGetMinMaxInfo(lpMMI);
    }

/****************************************************************************
*                    CImageComparatorDlg::DoDeferredResize
* Inputs:
*       HDWP & deferred:
*       int cx:
*       int cy:
* Result: void
*       
* Effect: 
*       Defers the windows being repositioned
****************************************************************************/

void CImageComparatorDlg::DoDeferredResize(HDWP & deferred, int cx, int cy)
    {
     if(c_HScroll.GetSafeHwnd() == NULL)
        return;

     CRect hscroll;
     c_HScroll.GetWindowRect(&hscroll);
     ScreenToClient(&hscroll);

     if(c_VScroll.GetSafeHwnd() == NULL)
        return;

     CRect vscroll;
     c_VScroll.GetWindowRect(&vscroll);
     ScreenToClient(&vscroll);


     //*****************************************************************************
     //                                                         :   :
     //                                                         |   |
     //                                                         +---+
     //                                                         | v |         |
     //                               c_HScroll                 +---+         V
     // +---+---------------------------------------------+---+ +---+  ---------
     // | < |                                             | > | |   |
     // +---+---------------------------------------------+---+ +---+  ---------
     //                                                                       ^
     //                                         vscroll.Width-->|   |<---     |
     //                                                         |   |         hscroll.Height
     //*****************************************************************************

     deferred = ::DeferWindowPos(deferred,
                                 c_HScroll.m_hWnd,
                                 NULL,
                                 0, (cy - hscroll.Height()),
                                 (cx - vscroll.Width()), hscroll.Height(),
                                 SWP_NOZORDER);

     //*****************************************************************************
     //                                 +---+
     //                                 | ^ |
     //                                 +---+
     //                                 |   |
     //                                 |   |  c_VScroll
     //                                 +---+
     //                                 | v |
     //    c_HScroll                    +---+
     // ...-----------------------+---+ +---+
     //                           | > | |///|  
     // ...-----------------------+---+ +---+
     //*****************************************************************************
     deferred = ::DeferWindowPos(deferred,
                                 c_VScroll.m_hWnd,
                                 NULL,
                                 (cx - vscroll.Width()), vscroll.top,
                                 vscroll.Width(), (cy - vscroll.top - hscroll.Height()),
                                 SWP_NOZORDER);

     int gap = 6 * ::GetSystemMetrics(SM_CXEDGE);

     int width = (cx - 2 * gap - vscroll.Width()) / 3;

     if(c_Image1.GetSafeHwnd() != NULL)
        { /* image 1 */
         CRect image1;
         c_Image1.GetWindowRect(&image1);
         ScreenToClient(&image1);

         deferred = ::DeferWindowPos(deferred,
                                     c_Image1.m_hWnd,
                                     NULL,
                                     0, 0,
                                     width, (cy - image1.top - hscroll.Height()),
                                     SWP_NOMOVE | SWP_NOZORDER);
        } /* image 1 */

     if(c_ImageDelta.GetSafeHwnd() != NULL)
        { /* image delta */
         CRect imageDelta;
         c_ImageDelta.GetWindowRect(&imageDelta);
         ScreenToClient(&imageDelta);


         deferred = ::DeferWindowPos(deferred,
                                     c_ImageDelta.m_hWnd,
                                     NULL,
                                     (width + gap), imageDelta.top,
                                     width, (cy - imageDelta.top - hscroll.Height()),
                                     SWP_NOZORDER);
        } /* image delta */

     if(c_Image2.GetSafeHwnd() != NULL)
        { /* image 2 */
         CRect image2;
         c_Image2.GetWindowRect(&image2);
         ScreenToClient(&image2);

         deferred = ::DeferWindowPos(deferred,
                                     c_Image2.m_hWnd,
                                     NULL,
                                     (2 * (width + gap)), image2.top,
                                     width, (cy - image2.top - hscroll.Height()),
                                     SWP_NOZORDER);
        } /* image 2 */

     //*****************************************************************************
     //                            +--------+
     //                            |  Save  |
     //                            +--------+
     //             +-----+ +-------------------+---+ +-----+
     //             |->.<-| | OR                | V | |  <--|
     //             +-----+ +-------------------+---+ +-----+
     //*****************************************************************************
     if(c_Save.GetSafeHwnd() != NULL)
        { /* move save */
         CRect r;
         c_Save.GetWindowRect(&r);
         ScreenToClient(&r);

         CPoint pt;
         pt.x = (cx - vscroll.Width()) / 2 - r.Width() / 2;
         pt.y = r.top;
         deferred = ::DeferWindowPos(deferred,
                                     c_Save.m_hWnd,
                                     NULL,
                                     pt.x, pt.y,
                                     0, 0,
                                     SWP_NOSIZE | SWP_NOZORDER);
        } /* move save */

     if(c_CombineBoth.GetSafeHwnd() != NULL &&
        c_CombineOp.GetSafeHwnd() != NULL &&
        c_CombineRight.GetSafeHwnd() != NULL)
        { /* combine */
         CRect both;
         c_CombineBoth.GetWindowRect(&both);
         ScreenToClient(&both);

         CRect op;
         c_CombineOp.GetWindowRect(&op);
         ScreenToClient(&op);

         CRect right;
         c_CombineRight.GetWindowRect(&right);
         ScreenToClient(&right);

         int buttongap = op.left - both.right;

         CPoint pt;
         pt.x = ((cx - vscroll.Width()) / 2) - op.Width() / 2;
         pt.y = op.top;
         
         deferred = ::DeferWindowPos(deferred,
                                     c_CombineOp.m_hWnd,
                                     NULL,
                                     pt.x, pt.y,
                                     0, 0, 
                                     SWP_NOZORDER | SWP_NOSIZE);
         
         CPoint b;
         b = pt;
         b.x = pt.x - both.Width() - buttongap;
         deferred = ::DeferWindowPos(deferred,
                                     c_CombineBoth.m_hWnd,
                                     NULL,
                                     b.x, b.y,
                                     0, 0,
                                     SWP_NOZORDER | SWP_NOSIZE);
         
         b = pt;
         b.x = pt.x + op.Width() + gap;
         deferred = ::DeferWindowPos(deferred,
                                     c_CombineRight.m_hWnd,
                                     NULL,
                                     b.x, b.y,
                                     0, 0,
                                     SWP_NOZORDER | SWP_NOSIZE);
        } /* combine */
     
     //*****************************************************************************
     //                       c_FileName2                      c_Browse2
     //                       +------------------------------+ +---+
     //                       |                              | |...|
     //                       +------------------------------+ +---+
     //*****************************************************************************

     if(c_FileName2.GetSafeHwnd() != NULL && c_Browse2.GetSafeHwnd() != NULL)
        { /* move edit control */
         CRect filename2;
         c_FileName2.GetWindowRect(&filename2);
         ScreenToClient(&filename2);

         CRect browse2;
         c_Browse2.GetWindowRect(&browse2);
         ScreenToClient(&browse2);

         deferred = ::DeferWindowPos(deferred,
                                     c_Browse2.m_hWnd,
                                     NULL,
                                     cx - vscroll.Width() - browse2.Width(),
                                     browse2.top,
                                     0, 0,
                                     SWP_NOSIZE | SWP_NOZORDER);

         deferred = ::DeferWindowPos(deferred,
                                     c_FileName2.m_hWnd,
                                     NULL,
                                     cx - vscroll.Width() - browse2.Width() - filename2.Width(),
                                     filename2.top,
                                     0, 0,
                                     SWP_NOSIZE | SWP_NOZORDER);
        } /* move edit control */
     //*****************************************************************************
     //
     //                              +------+
     //                              |  ||  |
     //                              |  ||  |
     //                              |  \/  |
     //                              +------+
     //*****************************************************************************
     if(c_OpenFile2.GetSafeHwnd() != NULL)
        { /* resize load file 2 */
         CRect open2;
         c_OpenFile2.GetWindowRect(&open2);
         ScreenToClient(&open2);

         deferred = ::DeferWindowPos(deferred,
                                     c_OpenFile2.m_hWnd,
                                     NULL,
                                     (cx - open2.Width() - vscroll.Width()), open2.top,
                                     open2.Width(), open2.Height(),
                                     SWP_NOZORDER);
        } /* resize load file 2 */

     //*****************************************************************************
     //
     //*****************************************************************************
     
    } // CImageComparatorDlg::DoDeferredResize

/****************************************************************************
*                      CImageComparatorDlg::SizeWindows
* Inputs:
*       int cx:
*       int cy:
* Result: void
*       
* Effect: 
*       Resizes the windows
****************************************************************************/

void CImageComparatorDlg::SizeWindows(int cx, int cy)
    {
     HDWP deferred = ::BeginDeferWindowPos(9); // first guess
     DoDeferredResize(deferred, cx, cy);
     ::EndDeferWindowPos(deferred);
     
    } // CImageComparatorDlg::SizeWindows

/****************************************************************************
*                         CImageComparatorDlg::OnSize
* Inputs:
*       UINT nType:
*       int cx:
*       int cy:
* Result: void
*       
* Effect: 
*       Resizes controls
****************************************************************************/

void CImageComparatorDlg::OnSize(UINT nType, int cx, int cy)
    {
     CDialog::OnSize(nType, cx, cy);

     SizeWindows(cx, cy);
    } // CImageComparatorDlg::OnSize


/****************************************************************************
*                       CImageComparatorDlg::OnNcHitTest
* Inputs:
*       CPoint point: Mouse cursor in screen coordinates
* Result: UINT
*       
* Effect: 
*       forces a hit test in the lower right corner to be interpreted as
*       a diagonal resize
****************************************************************************/

UINT CImageComparatorDlg::OnNcHitTest(CPoint point)
    {
     UINT hit = CDialog::OnNcHitTest(point);
     if(hit == HTCLIENT)
        { /* client hit */
         if(c_HScroll.GetSafeHwnd() != NULL && c_VScroll.GetSafeHwnd() != NULL)
            { /* see if hit */
             CRect hscroll;
             c_HScroll.GetWindowRect(&hscroll);

             CRect vscroll;
             c_VScroll.GetWindowRect(&vscroll);

             CRect r;
             GetClientRect(&r);
             ClientToScreen(&r);
             r.left = hscroll.right + 1;
             r.top = vscroll.bottom + 1;
             if(r.PtInRect(point))
                hit = HTBOTTOMRIGHT;
            } /* see if hit */
        } /* client hit */
    return hit;
    }


/****************************************************************************
*                    CImageComparatorDlg::OnBnClickedOpen1
* Result: void
*       
* Effect: 
*       Loads a picture into image1
****************************************************************************/

void CImageComparatorDlg::OnBnClickedOpen1()
    {
     LoadPicture(c_FileName1, c_Image1);
    }


/****************************************************************************
*                    CImageComparatorDlg::OnBnClickedOpen2
* Result: void
*       
* Effect: 
*       Loads a picture into image2
****************************************************************************/

void CImageComparatorDlg::OnBnClickedOpen2()
    {
     LoadPicture(c_FileName2, c_Image2);
    }


/****************************************************************************
*                     CImageComparatorDlg::OnEnChangeFile1
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CImageComparatorDlg::OnEnChangeFile1()
    {
     updateControls();
    }


/****************************************************************************
*                     CImageComparatorDlg::OnEnChangeFile2
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CImageComparatorDlg::OnEnChangeFile2()
    {
     updateControls();
    }

/****************************************************************************
*                      CImageComparatorDlg::LoadPicture
* Inputs:
*       CEdit & Name: Edit control that has image name
*       CPicture & Image: Image to load it into
* Result: void
*       
* Effect: 
*       Loads a picture
****************************************************************************/

void CImageComparatorDlg::LoadPicture(CEdit & Name, CPicture & Image)
    {
     CString filename;
     Name.GetWindowText(filename);
     filename.Trim();
     Image.Load(filename);
    } // CImageComparatorDlg::LoadPicture

/****************************************************************************
*                     CImageComparatorDlg::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CImageComparatorDlg::updateControls()
    {
     CString s;
     c_FileName1.GetWindowText(s);
     s.Trim();
     c_OpenFile1.EnableWindow(!s.IsEmpty());

     c_FileName2.GetWindowText(s);
     s.Trim();
     c_OpenFile2.EnableWindow(!s.IsEmpty());

     int n = c_CombineOp.GetCurSel();
     c_CombineBoth. EnableWindow(n >= 0 && c_Image1.IsValid() &&                           c_Image2.IsValid());
     c_CombineRight.EnableWindow(n >= 0 &&                       c_ImageDelta.IsValid() && c_Image2.IsValid());
    } // CImageComparatorDlg::updateControls


/****************************************************************************
*                   CImageComparatorDlg::OnBnClickedBrowse1
* Result: void
*       
* Effect: 
*       Browses for a file
****************************************************************************/

void CImageComparatorDlg::OnBnClickedBrowse1()
    {
     BrowseForFile(c_FileName1);
    }


/****************************************************************************
*                   CImageComparatorDlg::OnBnClickedBrowse2
* Result: void
*       
* Effect: 
*       Browses for a file
****************************************************************************/

void CImageComparatorDlg::OnBnClickedBrowse2()
    {
     BrowseForFile(c_FileName2);
    }

/****************************************************************************
*                     CImageComparatorDlg::BrowseForFile
* Inputs:
*       CEdit & Name: Place to put file name
* Result: void
*       
* Effect: 
*       Browses for an image file
****************************************************************************/

void CImageComparatorDlg::BrowseForFile(CEdit & Name)
    {
     CString filter;
     filter.LoadString(IDS_IMAGE_FILTER);

     CString defaultname;
     Name.GetWindowText(defaultname);
     CFileDialog dlg(TRUE, NULL, defaultname, OFN_HIDEREADONLY, filter);
     if(dlg.DoModal() != IDOK)
        return;

     Name.SetWindowText(dlg.GetPathName());
    } // CImageComparatorDlg::BrowseForFile


/****************************************************************************
*                 CImageComparatorDlg::OnBnClickedCombineBoth
* Result: void
*       
* Effect: 
*       Combines the left and right bitmaps
****************************************************************************/

void CImageComparatorDlg::OnBnClickedCombineBoth()
    {
     int n = c_CombineOp.GetCurSel();
     if(n < 0)
        return;
     UINT type = (UINT)c_CombineOp.GetItemData(n);
     
     c_ImageDelta.MakeTarget(c_Image1);
     c_ImageDelta.Transfer(c_Image1, SRCCOPY);
     c_ImageDelta.Transfer(c_Image2, type);
    }


/****************************************************************************
*                 CImageComparatorDlg::OnBnClickedCombineRight
* Result: void
*       
* Effect: 
*       Combines the right bitmap with the center
****************************************************************************/

void CImageComparatorDlg::OnBnClickedCombineRight()
    {
     if(!c_ImageDelta.IsValid())
         return;
     int n = c_CombineOp.GetCurSel();
     if(n < 0)
         return;
     UINT type = (UINT)c_CombineOp.GetItemData(n);

     c_ImageDelta.Transfer(c_Image2, type);
    }


/****************************************************************************
*                     CImageComparatorDlg::OnBnClickedSave
* Result: void
*       
* Effect: 
*       Saves the middle image
****************************************************************************/

void CImageComparatorDlg::OnBnClickedSave()
    {
     CString filter;
     filter.LoadString(IDS_SAVE_FILTER);

     CString ext;
     REFGUID type = Gdiplus::ImageFormatBMP;
     if(type == Gdiplus::ImageFormatBMP)
        ext = _T(".bmp");
     else
     if(type == Gdiplus::ImageFormatPNG)
        ext = _T(".png");
     else
     if(type == Gdiplus::ImageFormatJPEG)
        ext = _T(".jpg");
     else
     if(type == Gdiplus::ImageFormatGIF)
        ext = _T(".gif");
     else
     if(type == Gdiplus::ImageFormatTIFF)
        ext = _T(".tif");

     CFileDialog dlg(FALSE, ext, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, filter);
     if(dlg.DoModal() != IDOK)
        return;

     
     c_ImageDelta.Save(dlg.GetPathName(), type);
    }


/****************************************************************************
*                  CImageComparatorDlg::OnCbnSelendokCombine
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CImageComparatorDlg::OnCbnSelendokCombine()
    {
     updateControls();
    }
